const app = getApp()
Page({
  onLoad(query) {
    const _that = this;
    dd.setNavigationBar({title: ''});
    //判断有无网络，判断是否离线
    dd.showLoading({
      content: '加载中...',
    });
    dd.getNetworkType({
      success: (res) => {
        if (res.networkAvailable) {
          dd.getAuthCode({
            success:function(res){
              // 获取用户信息
              _that.getUserMsg(res.authCode)
            },
            fail:function(err){
              console.log(err)
            }
          });
        } else {
          if (dd.getStorageSync({ key: 'userId' }).data) {
            dd.redirectTo({
              url: '/pages/index/index'
            })
          } else {
            dd.alert({
              content: '系统繁忙',
              buttonText: '确定'
            });
          }
        }
      }
    });    
  },
  // 有网络的状态更新用户userId和token
  getUserMsg(code) {
    const _that = this;
    let token = dd.getStorageSync({ key: 'token' }).data ? dd.getStorageSync({ key: 'token' }).data.access_token : '';
    let orgId = dd.corpId;
    dd.httpRequest({
      headers: {
        "Content-Type": "application/json",
        "Authorization": `Bearer ${token}`
      },
      url: `http://${app.globalData.globalUrl}/v1/auth/userToken?version=v1&code=${code}&token=${token}&orgId=${orgId}`,
      method: 'POST',
      dataType: 'json',
      success: function(res) {
        console.log(res)
        // 全局存储用户信息token和用户信息
        if(res.data.resultCode === '0'){
          const data = res.data.data;
          // 更新用户内部信息
          dd.setStorageSync({
            key: 'token',
            data: {
              access_token: data.accessToken.access_token,
              token_type: data.accessToken.token_type,
              expires_in: data.accessToken.expires_in,
              loginTime: (new Date()).getTime()
            }
          });
          dd.setStorageSync({
            key: 'userId',
            data: data.oapiUser.userid
          });
          dd.setStorageSync({
            key: 'avatar',
            data: data.oapiUser.avatar
          });
          dd.hideLoading();
          dd.redirectTo({
            url: '/pages/index/index'
          })
        }else{
          dd.hideLoading();
          dd.redirectTo({
            url: '/pages/noPermission/noPermission'
          })
        }  
      },
      fail: function(res) {
        console.log('err',res)
        dd.alert({
          content: '系统繁忙',
          buttonText: '确定'
        });
        dd.hideLoading();
      }
    });
  },
  onReady() {
    // 页面加载完成
  },
  onShow() {
    // 页面显示
  },
  onHide() {
    // 页面隐藏
  },
  onUnload() {
    // 页面被关闭
  },
  onTitleClick() {
    // 标题被点击
  },
  onPullDownRefresh() {
    // 页面被下拉
  },
  onReachBottom() {
    // 页面被拉到底部
  },
  onShareAppMessage() {
    // 返回自定义分享信息
    return {
      title: 'My App',
      desc: 'My App description',
      path: 'pages/index/index',
    };
  },
});
